# all files / ol/ size.js

96.55% Statements 28/29
83.33% Branches 10/12
80% Functions 4/5
96.55% Lines 28/29

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    941×
    1×

    1×

    1×

    1×
    3×
    1×

    3×
    3×
    3×

    1×

    1×
    94×

    1×
    11×
    1×

    11×
    11×
    11×

    1×
    7400×
    573×

    6827×
    6827×
    3665×

    3162×
    3162×

    6827×

     goog.provide('ol.Size');
    goog.provide('ol.size');

    goog.require('goog.asserts');

    /**
     * An array of numbers representing a size: `[width, height]`.
     * @typedef {Array.<number>}
     * @api stable
     */
    ol.Size;

    /**
     * Returns a buffered size.
     * @param {ol.Size} size Size.
     * @param {number} buffer Buffer.
     * @param {ol.Size=} opt_size Optional reusable size array.
     * @return {ol.Size}
     */
    ol.size.buffer = function(size, buffer, opt_size) {
      if (opt_size === undefined) {
        opt_size = [0, 0];
      }
      opt_size[0] = size[0] + 2 * buffer;
      opt_size[1] = size[1] + 2 * buffer;
      return opt_size;
    };

    /**
     * Compares sizes for equality.
     * @param {ol.Size} a Size.
     * @param {ol.Size} b Size.
     * @return {boolean} Equals.
     */
    ol.size.equals = function(a, b) {
      return a[0] == b[0] && a[1] == b[1];
    };

    /**
     * Determines if a size has a positive area.
     * @param {ol.Size} size The size to test.
     * @return {boolean} The size has a positive area.
     */
    ol.size.hasArea = function(size) {
      return size[0] > 0 && size[1] > 0;
    };

    /**
     * Returns a size scaled by a ratio. The result will be an array of integers.
     * @param {ol.Size} size Size.
     * @param {number} ratio Ratio.
     * @param {ol.Size=} opt_size Optional reusable size array.
     * @return {ol.Size}
     */
    ol.size.scale = function(size, ratio, opt_size) {
      if (opt_size === undefined) {
        opt_size = [0, 0];
      }
      opt_size[0] = (size[0] * ratio + 0.5) | 0;
      opt_size[1] = (size[1] * ratio + 0.5) | 0;
      return opt_size;
    };

    /**
     * Returns an `ol.Size` array for the passed in number (meaning: square) or
     * `ol.Size` array.
     * (meaning: non-square),
     * @param {number|ol.Size} size Width and height.
     * @param {ol.Size=} opt_size Optional reusable size array.
     * @return {ol.Size} Size.
     * @api stable
     */
    ol.size.toSize = function(size, opt_size) {
      if (goog.isArray(size)) {
        return size;
      } else {
        goog.asserts.assert(goog.isNumber(size));
        if (opt_size === undefined) {
          opt_size = [size, size];
        } else {
          opt_size[0] = size;
          opt_size[1] = size;
        }
        return opt_size;
      }
    };